//*************************************************************
//	   ؍\\̓mF
//			uTreeTestv
//
//@@@@@@@@@@@@ҁF[g؁@@@
//@@@@@@@@@@쐬JnFQOOV^W
//@@@@@@@@@@ŏIXVFQOOV^PP  [TN115/J105]
//*************************************************************

import java.awt.Color;
import java.awt.FileDialog;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.DefaultCellEditor;
import javax.swing.ImageIcon;
import javax.swing.JColorChooser;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.JTree;
import javax.swing.event.TreeExpansionEvent;
import javax.swing.event.TreeExpansionListener;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.event.TreeWillExpandListener;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.ExpandVetoException;
import javax.swing.tree.TreePath;


public class TreeTest extends JFrame implements TreeSelectionListener, TreeWillExpandListener, TreeExpansionListener, ActionListener {
	//EclipsȅꍇAVACY\NXłꂪȂƌxo
	private static final long serialVersionUID=0;

	public static void main(String[] args) {
		TreeTest frame=new TreeTest();
		frame.setTitle("TreeTest");
		//
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);	//E~ŏI
		frame.setSize(300,500);
		frame.setVisible(true);
		frame.setLocationRelativeTo(null);	//ʂ̐^񒆂ɕ\
	}
	//
	JTree tree;
	DefaultMutableTreeNode root;
	DefaultTreeCellRenderer renderer;
	//
	JMenuBar menu=new JMenuBar();
	JMenu add=new JMenu("add");
	JMenuItem addNonnameChild=new JMenuItem("non-named child");
	JMenuItem addNameChild=new JMenuItem("named child...");
	JMenuItem addNonnameUp=new JMenuItem("non-named upper");
	JMenuItem addNameUp=new JMenuItem("named upper...");
	JMenu remove=new JMenu("remove");
	JMenuItem removeSelf=new JMenuItem("self");
	JMenuItem removeChildren=new JMenuItem("all children");
	JMenu move=new JMenu("move");
	JMenuItem moveUp=new JMenuItem("up");
	JMenuItem moveDown=new JMenuItem("down");
	JMenu color=new JMenu("color");
	JMenuItem colorSelectText=new JMenuItem("selected text...");
	JMenuItem colorSelectBack=new JMenuItem("selected back...");
	JMenuItem colorNonselectText=new JMenuItem("non-selected text...");
	JMenuItem colorNonselectBack=new JMenuItem("non-selected back...");
	JMenu icon=new JMenu("icon");
	JMenuItem iconClosed=new JMenuItem("closed...");
	JMenuItem iconOpen=new JMenuItem("open...");
	JMenuItem iconLeaf=new JMenuItem("leaf...");
	JMenu others=new JMenu("others");
	JMenuItem format=new JMenuItem("foramt");
	JMenuItem rename=new JMenuItem("rename...");
	//
	public TreeTest(){
		//********************************************
		add.add(addNonnameChild);
		add.add(addNameChild);
		add.addSeparator();
		add.add(addNonnameUp);
		add.add(addNameUp);
		remove.add(removeSelf);
		remove.add(removeChildren);
		move.add(moveUp);
		move.add(moveDown);
		color.add(colorSelectText);
		color.add(colorSelectBack);
		color.addSeparator();
		color.add(colorNonselectText);
		color.add(colorNonselectBack);
		others.add(format);
		others.addSeparator();
		others.add(rename);
		icon.add(iconClosed);
		icon.add(iconOpen);
		icon.addSeparator();
		icon.add(iconLeaf);
		menu.add(add);
		menu.add(remove);
		menu.add(move);
		menu.add(color);
		menu.add(icon);
		menu.add(others);
		setJMenuBar(menu);
		//
		addNonnameChild.addActionListener(this);
		addNameChild.addActionListener(this);
		addNonnameUp.addActionListener(this);
		addNameUp.addActionListener(this);
		removeSelf.addActionListener(this);
		removeChildren.addActionListener(this);
		moveUp.addActionListener(this);
		moveDown.addActionListener(this);
		colorSelectText.addActionListener(this);
		colorSelectBack.addActionListener(this);
		colorNonselectText.addActionListener(this);
		colorNonselectBack.addActionListener(this);
		iconClosed.addActionListener(this);
		iconOpen.addActionListener(this);
		iconLeaf.addActionListener(this);
		format.addActionListener(this);
		rename.addActionListener(this);
		//********************************************
		//
		formatTree();
		//
		tree.addTreeSelectionListener(this);
		tree.addTreeWillExpandListener(this);
		tree.addTreeExpansionListener(this);
	}
	private void formatTree(){
		DefaultMutableTreeNode kitamura=new DefaultMutableTreeNode("kO");
		DefaultMutableTreeNode kitamura01=new DefaultMutableTreeNode("Ԕn");
		DefaultMutableTreeNode kitamura02=new DefaultMutableTreeNode("XLbv");
		DefaultMutableTreeNode kitamura03=new DefaultMutableTreeNode("ʍƂ͓l");
		kitamura.add(kitamura01);
		kitamura.add(kitamura02);
		kitamura.add(kitamura03);
		DefaultMutableTreeNode kanou=new DefaultMutableTreeNode("[q");
		DefaultMutableTreeNode kanou01=new DefaultMutableTreeNode("ȂȂ̂");
		DefaultMutableTreeNode kanou02=new DefaultMutableTreeNode("΂񏉂߂ɂC");
		kanou.add(kanou01);
		kanou.add(kanou02);
		DefaultMutableTreeNode wakatake=new DefaultMutableTreeNode("|C");
		DefaultMutableTreeNode sakaki=new DefaultMutableTreeNode("؎i");
		root=new DefaultMutableTreeNode("mystery");
		root.add(kitamura);
		root.add(kanou);
		root.add(wakatake);
		root.add(sakaki);
		//
		tree=new JTree(root);
		//FACRύX\
		renderer=new DefaultTreeCellRenderer();
		tree.setCellRenderer(renderer);
		//ڃeLXgtB[hœ͉\
		tree.setEditable(true);
		DefaultCellEditor editor=new DefaultCellEditor(new JTextField(10));
		tree.setCellEditor(editor);
		//
		JScrollPane scPanel=new JScrollPane(tree);
		getContentPane().add(scPanel);
	}
	//-------------------------------------------------------------------
	//c[Cxg
	//-------------------------------------------------------------------
	//I͈͂ύXꂽ
	public void valueChanged(TreeSelectionEvent e) {
		TreePath[] paths=tree.getSelectionPaths();
		if(paths==null){
			setTitle("TreeTest");
			return;
		}
		//Ō̑ISẴpX擾^Cgɕ\
		Object[] nodes=paths[paths.length-1].getPath();
		StringBuffer buf=new StringBuffer("TreeTest ");
		for(int n=0;n<nodes.length;n++){
			buf.append("["+nodes[n].toString()+"]-");
		}
		buf.delete(buf.length()-1, buf.length());
		setTitle(buf.toString());
	}
	//WJE܂肽݂̑O
	public void treeWillCollapse(TreeExpansionEvent arg0) throws ExpandVetoException {
	}
	public void treeWillExpand(TreeExpansionEvent arg0) throws ExpandVetoException {
	}
	//WJE܂肽݂̌
	public void treeCollapsed(TreeExpansionEvent arg0) {
	}
	public void treeExpanded(TreeExpansionEvent arg0) {
	}
	//-------------------------------------------------------------------
	//j[Cxg
	//-------------------------------------------------------------------
	public void actionPerformed(ActionEvent e) {
		Object object=e.getSource();
		if(object==addNonnameChild){				//***Ow肹Ɏqm[hǉ
			if(tree.getSelectionCount()!=1){
				JOptionPane.showMessageDialog(this,"PAIĂ","G[",JOptionPane.ERROR_MESSAGE);
				return;
			}
			//
			DefaultMutableTreeNode node=(DefaultMutableTreeNode)tree.getLastSelectedPathComponent();
			DefaultMutableTreeNode tmpNode=new DefaultMutableTreeNode("item");
			node.add(tmpNode);
			//ύXʒm
			DefaultTreeModel model=(DefaultTreeModel)tree.getModel();
			model.reload(node);
			//ǉm[hI
			tree.clearSelection();
			tree.addSelectionPath(new TreePath(tmpNode.getPath()));
		}else if(object==addNameChild){				//***Ow肵Ďqm[hǉ
			if(tree.getSelectionCount()!=1){
				JOptionPane.showMessageDialog(this,"PAIĂ","G[",JOptionPane.ERROR_MESSAGE);
				return;
			}
			//
			String ret=JOptionPane.showInputDialog(this,"O͂Ă");
			if(ret!=null){
				DefaultMutableTreeNode node=(DefaultMutableTreeNode)tree.getLastSelectedPathComponent();
				DefaultMutableTreeNode tmpNode=new DefaultMutableTreeNode(ret);
				node.add(tmpNode);
				//ύXʒm
				DefaultTreeModel model=(DefaultTreeModel)tree.getModel();
				model.reload(node);
				//ǉm[hI
				tree.clearSelection();
				tree.addSelectionPath(new TreePath(tmpNode.getPath()));
			}
		}else if(object==addNonnameUp){				//***Ow肹Ɏ̑OɃm[hǉ
			if(tree.getSelectionCount()!=1){
				JOptionPane.showMessageDialog(this,"PAIĂ","G[",JOptionPane.ERROR_MESSAGE);
				return;
			}
			//
			DefaultMutableTreeNode node=(DefaultMutableTreeNode)tree.getLastSelectedPathComponent();
			if(!node.isRoot()){
				DefaultMutableTreeNode parent=(DefaultMutableTreeNode)node.getParent();
				int pos=parent.getIndex(node);			//̈ʒu
				if(pos!=-1){
					DefaultMutableTreeNode tmpNode=new DefaultMutableTreeNode("item");
					parent.insert(tmpNode,pos);			//ʒuɓ΂
					//ύXʒm
					DefaultTreeModel model=(DefaultTreeModel)tree.getModel();
					model.reload(parent);
					//ǉm[hI
					tree.addSelectionPath(new TreePath(tmpNode.getPath()));
				}
			}else{
				JOptionPane.showMessageDialog(this,"[gɂ͒ǉł܂","G[",JOptionPane.ERROR_MESSAGE);
			}
		}else if(object==addNameUp){				//***Ow肵Ď̑OɃm[hǉ
			if(tree.getSelectionCount()!=1){
				JOptionPane.showMessageDialog(this,"PAIĂ","G[",JOptionPane.ERROR_MESSAGE);
				return;
			}
			//
			DefaultMutableTreeNode node=(DefaultMutableTreeNode)tree.getLastSelectedPathComponent();
			if(!node.isRoot()){
				DefaultMutableTreeNode parent=(DefaultMutableTreeNode)node.getParent();
				int pos=parent.getIndex(node);			//̈ʒu
				if(pos!=-1){
					//
					String ret=JOptionPane.showInputDialog(this,"O͂Ă");
					if(ret!=null){
						DefaultMutableTreeNode tmpNode=new DefaultMutableTreeNode(ret);
						parent.insert(tmpNode,pos);		//ʒuɓ΂
						//ύXʒm
						DefaultTreeModel model=(DefaultTreeModel)tree.getModel();
						model.reload(parent);
						//ǉm[hI
						tree.addSelectionPath(new TreePath(tmpNode.getPath()));
					}
				}
			}else{
				JOptionPane.showMessageDialog(this,"[gɂ͒ǉł܂","G[",JOptionPane.ERROR_MESSAGE);
			}
		}else if(object==removeSelf){				//***gƂ̎qm[hSĂ폜
			if(tree.getSelectionCount()<=0){
				JOptionPane.showMessageDialog(this,"PȏAIĂ","G[",JOptionPane.ERROR_MESSAGE);
				return;
			}
			//IĂSĂɑ΂
			TreePath[] paths=tree.getSelectionPaths();
			for(int p=0;p<paths.length;p++){
				DefaultMutableTreeNode target=(DefaultMutableTreeNode)paths[p].getLastPathComponent();
				target.removeFromParent();
			}
			//ύXʒm
			DefaultTreeModel model=(DefaultTreeModel)tree.getModel();
			model.reload();
		}else if(object==removeChildren){			//***̎qm[hSč폜
			if(tree.getSelectionCount()<=0){
				JOptionPane.showMessageDialog(this,"PȏAIĂ","G[",JOptionPane.ERROR_MESSAGE);
				return;
			}
			//IĂSĂɑ΂
			TreePath[] paths=tree.getSelectionPaths();
			for(int p=0;p<paths.length;p++){
				DefaultMutableTreeNode target=(DefaultMutableTreeNode)paths[p].getLastPathComponent();
				target.removeAllChildren();
			}
			//ύXʒm
			DefaultTreeModel model=(DefaultTreeModel)tree.getModel();
			model.reload();
		}else if(object==moveUp){					//***OɈړ
			if(tree.getSelectionCount()!=1){
				JOptionPane.showMessageDialog(this,"PAIĂ","G[",JOptionPane.ERROR_MESSAGE);
				return;
			}
			//
			DefaultMutableTreeNode node=(DefaultMutableTreeNode)tree.getLastSelectedPathComponent();
			if(!node.isRoot()){
				DefaultMutableTreeNode parent=(DefaultMutableTreeNode)node.getParent();
				int pos=parent.getIndex(node);			//݂̈ʒu
				if(pos>0){								//ԑOłȂ΂POɂ炷
					parent.insert(node,pos-1);
					//ύXʒm
					DefaultTreeModel model=(DefaultTreeModel)tree.getModel();
					model.reload(parent);
					//ړm[hI
					tree.addSelectionPath(new TreePath(node.getPath()));
				}
			}else{
				JOptionPane.showMessageDialog(this,"[g͈ړł܂","G[",JOptionPane.ERROR_MESSAGE);
			}
		}else if(object==moveDown){					//***Ɉړ
			if(tree.getSelectionCount()!=1){
				JOptionPane.showMessageDialog(this,"PAIĂ","G[",JOptionPane.ERROR_MESSAGE);
				return;
			}
			//
			DefaultMutableTreeNode node=(DefaultMutableTreeNode)tree.getLastSelectedPathComponent();
			if(!node.isRoot()){
				DefaultMutableTreeNode parent=(DefaultMutableTreeNode)node.getParent();
				int pos=parent.getIndex(node);			//݂̈ʒu
				if(pos!=-1){
					if(pos<parent.getChildCount()-1){	//ԌłȂ΂Pɂ炷
						parent.insert(node,pos+1);
						//ύXʒm
						DefaultTreeModel model=(DefaultTreeModel)tree.getModel();
						model.reload(parent);
						//ړm[hI
						tree.addSelectionPath(new TreePath(node.getPath()));
					}
				}
			}else{
				JOptionPane.showMessageDialog(this,"[g͈ړł܂","G[",JOptionPane.ERROR_MESSAGE);
			}
		}else if(object==colorSelectText){			//***ĨeLXgFύX
			Color cc=JColorChooser.showDialog(null,"IeLXgF",renderer.getTextSelectionColor());
			renderer.setTextSelectionColor(cc);
		}else if(object==colorSelectBack){			//***I̔wiFύX
			Color cc=JColorChooser.showDialog(null,"IwiF",renderer.getBackgroundSelectionColor());
			renderer.setBackgroundSelectionColor(cc);
		}else if(object==colorNonselectText){		//***ĨeLXgFύX
			Color cc=JColorChooser.showDialog(null,"ĨeLXgF",renderer.getTextNonSelectionColor());
			renderer.setTextNonSelectionColor(cc);
		}else if(object==colorNonselectBack){		//***I̔wiFύX
			Color cc=JColorChooser.showDialog(null,"I̔wiF",renderer.getBackgroundNonSelectionColor());
			renderer.setBackgroundNonSelectionColor(cc);
		}else if(object==iconClosed){				//***ACRύX
			ImageIcon icon=getIcon();
			if(icon!=null){
				renderer.setClosedIcon(icon);
			}
		}else if(object==iconOpen){					//***JACRύX
			ImageIcon icon=getIcon();
			if(icon!=null){
				renderer.setOpenIcon(icon);
			}
		}else if(object==iconLeaf){					//***tACRύX
			ImageIcon icon=getIcon();
			if(icon!=null){
				renderer.setLeafIcon(icon);
			}
		}else if(object==format){					//***
			getContentPane().removeAll();
			formatTree();
			//
			setVisible(true);
		}else if(object==rename){					//***ύX
			if(tree.getSelectionCount()!=1){
				JOptionPane.showMessageDialog(this,"PAIĂ","G[",JOptionPane.ERROR_MESSAGE);
				return;
			}
			//
			DefaultMutableTreeNode node=(DefaultMutableTreeNode)tree.getLastSelectedPathComponent();
			String ret=JOptionPane.showInputDialog(this,"VOɒĂ",(String)node.getUserObject());
			if(ret!=null){
				node.setUserObject(ret);
				//ύXʒm
				DefaultTreeModel model=(DefaultTreeModel)tree.getModel();
				model.nodeChanged(node);
				//ύXm[hIisvj
				//tree.addSelectionPath(new TreePath(node.getPath()));
			}
		}
	}
	//摜t@C[hăACRɂĕԂ
	private ImageIcon getIcon(){
		FileDialog flDialog=new FileDialog(this);
		flDialog.setMode(FileDialog.LOAD);
		flDialog.setTitle("摜t@CI");
		flDialog.setVisible(true);
		if(flDialog.getFile()!=null){
			String path=flDialog.getDirectory()+flDialog.getFile();
			ImageIcon icon=new ImageIcon(path);
			//
			return icon;
		}else{
			return null;
		}
	}
}
